#
# Copyright 2011 Eigenlabs Ltd.  http://www.eigenlabs.com
#
# This file is part of EigenD.
#
# EigenD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# EigenD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with EigenD.  If not, see <http://www.gnu.org/licenses/>.
#

import piw
from pi import agent, domain, bundles,atom
from plg_midiilluminator import alpha_midi_light_controller_version as version

import midiilluminator_plg

class AlphaAgent(midiilluminator_plg.IlluminatorAgent):
    def __init__(self, address, ordinal):
        super(AlphaAgent, self).__init__(address,ordinal,120,'alpha midi light controller')
        self.num_keys_per_row = 5
    def _default_note(self, key):
        s = 37
        default_note = 0
        row = (key - 1) % 24
        if row < 23:
            default_note = row + (key - 1) / 24 * 4 + s + 1
        return default_note
    def _num_keys_in_column(self, column):
        return 24
    def _num_layouts(self):
        return 10
    def is_lite(self):
        return False
    
agent.main(AlphaAgent)
