
/*
 Copyright 2009 Eigenlabs Ltd.  http://www.eigenlabs.com

 This file is part of EigenD.

 EigenD is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 EigenD is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with EigenD.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MIDIILLUMINATOR__
#define __MIDIILLUMINATOR__

#include "midiilluminator_exports.h"

#include <piw/piw_bundle.h>
#include <piw/piw_data.h>
#include <piw/piw_clock.h>

namespace midiilluminator_plg
{
    /*
     TODO
     */
    class MIDIILLUMINATOR_PLG_DECLSPEC_CLASS midiilluminator_t : public pic::nocopy_t
    {
        public:
            class impl_t;
        
            midiilluminator_t(piw::clockdomain_ctl_t *, const piw::cookie_t &, const unsigned& num_keys);
            ~midiilluminator_t();
            piw::cookie_t cookie();
            void set_transpose(int semitones);
            void set_direct_keys_prio(unsigned prio);
            void set_direct_notes_prio(unsigned prio);
            void set_midi_prio(unsigned prio);
            void set_enable_direct_keys_for_color(unsigned color, bool enabled);
            void set_enable_direct_notes_for_color(unsigned color, bool enabled);
            void set_enable_midi_for_color(unsigned color, bool enabled);
            void set_key(unsigned key, unsigned color);
            void set_note(unsigned note, unsigned color);
            void set_channel_color(unsigned channel, unsigned color);
            void set_note_for_key(unsigned key, unsigned note, bool refresh);
            void set_enable(bool state);
        private:
            impl_t *impl_;
    };
}

#endif

